Index: squid/src/comm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm.c,v
retrieving revision 1.1.1.3.4.1.2.10
retrieving revision 1.1.1.3.4.1.2.11
diff -u -r1.1.1.3.4.1.2.10 -r1.1.1.3.4.1.2.11
--- squid/src/comm.c	6 Apr 2002 17:37:38 -0000	1.1.1.3.4.1.2.10
+++ squid/src/comm.c	30 Apr 2002 17:21:49 -0000	1.1.1.3.4.1.2.11
@@ -1,6 +1,6 @@
 
 /*
- * $Id: comm.c,v 1.1.1.3.4.1.2.10 2002/04/06 17:37:38 serassio Exp $
+ * $Id: comm.c,v 1.1.1.3.4.1.2.11 2002/04/30 17:21:49 serassio Exp $
  *
  * DEBUG: section 5     Socket Functions
  * AUTHOR: Harvest Derived
@@ -71,44 +71,13 @@
 static int commResetFD(ConnectStateData * cs);
 static int commRetryConnect(ConnectStateData * cs);
 
-#ifdef _SQUID_MSWIN_
-void
-commSetSelectS(int sd, unsigned int type, PF * handler, void *client_data, time_t timeout)
-{
-    sde *F = &sd_table[sd];
-    assert(sd >= 0);
-    assert(F->flags.open);
-    debug(5, 5) ("commSetSelect: SD %d type %d\n", sd, type);
-    if (type & COMM_SELECT_READ) {
-	F->read_handler = handler;
-	F->read_data = client_data;
-	commUpdateReadBitsS(sd, handler);
-    }
-    if (type & COMM_SELECT_WRITE) {
-	F->write_handler = handler;
-	F->write_data = client_data;
-	commUpdateWriteBitsS(sd, handler);
-    }
-    if (timeout)
-	F->timeout = squid_curtime + timeout;
-}
-#endif
-
 static void
 CommWriteStateCallbackAndFree(int fd, int code)
 {
-#ifdef _SQUID_MSWIN_
-    CommWriteStateData *CommWriteState = sd_table[fd].rwstate;
-#else
     CommWriteStateData *CommWriteState = fd_table[fd].rwstate;
-#endif
     CWCB *callback = NULL;
     void *data;
-#ifdef _SQUID_MSWIN_
-    sd_table[fd].rwstate = NULL;
-#else
     fd_table[fd].rwstate = NULL;
-#endif
     if (CommWriteState == NULL)
 	return;
     if (CommWriteState->free_func) {
@@ -130,11 +99,7 @@
 {
     struct sockaddr_in addr;
     socklen_t addr_len = 0;
-#ifdef _SQUID_MSWIN_
-    sde *F = &sd_table[fd];
-#else
     fde *F = &fd_table[fd];
-#endif
 
     /* If the fd is closed already, just return */
     if (!F->flags.open) {
@@ -184,24 +149,10 @@
     const char *note)
 {
     int new_socket;
-#ifdef _SQUID_MSWIN_
-    sde *F = NULL;
-    int err;
-#else
     fde *F = NULL;
-#endif
 
     /* Create socket for accepting new connections. */
     Counter.syscalls.sock.sockets++;
-#ifdef _SQUID_MSWIN_
-    if ((new_socket = (int) socket(AF_INET, sock_type, proto)) == INVALID_SOCKET) {
-	/* Increase the number of reserved fd's if calls to socket()
-	 * are failing because the open file table is full.  This
-	 * limits the number of simultaneous clients */
-	err=WSAGetLastError();
-	switch (err) {
-	case WSAEMFILE:
-#else
     if ((new_socket = socket(AF_INET, sock_type, proto)) < 0) {
 	/* Increase the number of reserved fd's if calls to socket()
 	 * are failing because the open file table is full.  This
@@ -209,7 +160,6 @@
 	switch (errno) {
 	case ENFILE:
 	case EMFILE:
-#endif
 	    debug(50, 1) ("comm_open: socket failure: %s\n", xstrerror());
 	    fdAdjustReserved();
 	    break;
@@ -221,18 +171,14 @@
     /* update fdstat */
     debug(5, 5) ("comm_open: FD %d is a new socket\n", new_socket);
     fd_open(new_socket, FD_SOCKET, note);
-#ifdef _SQUID_MSWIN_
-    F = &sd_table[new_socket];
-#else
     F = &fd_table[new_socket];
-#endif
     if (!(flags & COMM_NOCLOEXEC))
 	commSetCloseOnExec(new_socket);
     if ((flags & COMM_REUSEADDR))
 	commSetReuseAddr(new_socket);
     if (port > (u_short) 0) {
 #ifdef _SQUID_MSWIN_
-	if ( sock_type != SOCK_DGRAM && proto != IPPROTO_UDP )
+	if (sock_type != SOCK_DGRAM)
 #endif
 	commSetNoLinger(new_socket);
 	if (opt_reuseaddr)
@@ -352,54 +298,26 @@
 static int
 commResetFD(ConnectStateData * cs)
 {
-#ifdef _SQUID_MSWIN_
-    int err;
-#endif
     int fd2;
     if (!cbdataValid(cs->data))
 	return 0;
-#ifdef _SQUID_MSWIN_
-    closesocket(cs->fd);
-    return 0;
-#endif
-    Counter.syscalls.sock.sockets++;
-#ifdef _SQUID_MSWIN_
-    fd2 = (int) socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
     Counter.syscalls.sock.sockets++;
-    if (fd2 == INVALID_SOCKET) {
-	err=WSAGetLastError();
-	debug(5, 0) ("commResetFD: socket: %s\n", xstrerror());
-	if (WSAEMFILE == h_errno)
-#else    
     fd2 = socket(AF_INET, SOCK_STREAM, 0);
     Counter.syscalls.sock.sockets++;
     if (fd2 < 0) {
 	debug(5, 0) ("commResetFD: socket: %s\n", xstrerror());
 	if (ENFILE == errno || EMFILE == errno)
-#endif
 	    fdAdjustReserved();
 	return 0;
     }
     if (dup2(fd2, cs->fd) < 0) {
-#ifdef _SQUID_MSWIN_
-	err=WSAGetLastError();
-#endif
 	debug(5, 0) ("commResetFD: dup2: %s\n", xstrerror());
-#ifdef _SQUID_MSWIN_
-	if (WSAEMFILE == err)
-#else
 	if (ENFILE == errno || EMFILE == errno)
-#endif
 	    fdAdjustReserved();
 	return 0;
     }
-#ifdef _SQUID_MSWIN_
-    closesocket(fd2);
-    sd_table[cs->fd].flags.called_connect = 0;
-#else
     close(fd2);
     fd_table[cs->fd].flags.called_connect = 0;
-#endif
     /*
      * yuck, this has assumptions about comm_open() arguments for
      * the original socket
@@ -450,11 +368,7 @@
     switch (comm_connect_addr(fd, &cs->S)) {
     case COMM_INPROGRESS:
 	debug(5, 5) ("commConnectHandle: FD %d: COMM_INPROGRESS\n", fd);
-#ifdef _SQUID_MSWIN_
-	commSetSelectS(fd, COMM_SELECT_WRITE, commConnectHandle, cs, 0);
-#else
 	commSetSelect(fd, COMM_SELECT_WRITE, commConnectHandle, cs, 0);
-#endif
 	break;
     case COMM_OK:
 	ipcacheMarkGoodAddr(cs->host, cs->S.sin_addr);
@@ -478,19 +392,11 @@
 int
 commSetTimeout(int fd, int timeout, PF * handler, void *data)
 {
-#ifdef _SQUID_MSWIN_
-    sde *F;
-#else
     fde *F;
-#endif
     debug(5, 3) ("commSetTimeout: FD %d timeout %d\n", fd, timeout);
     assert(fd >= 0);
     assert(fd < Squid_MaxFD);
-#ifdef _SQUID_MSWIN_
-	F = &sd_table[fd];
-#else
 	F = &fd_table[fd];
-#endif
     assert(F->flags.open);
     if (timeout < 0) {
 	F->timeout_handler = NULL;
@@ -509,11 +415,7 @@
 comm_connect_addr(int sock, const struct sockaddr_in *address)
 {
     int status = COMM_OK;
-#ifdef _SQUID_MSWIN_
-    sde *F = &sd_table[sock];
-#else
     fde *F = &fd_table[sock];
-#endif
     int x;
     int err = 0;
     socklen_t errlen;
@@ -525,14 +427,7 @@
 	Counter.syscalls.sock.connects++;
 	x = connect(sock, (struct sockaddr *) address, sizeof(*address));
 	if (x < 0)
-#ifdef _SQUID_MSWIN_
-	{
-	    err=WSAGetLastError();
-	    debug(5, 9) ("connect FD %d: %s\n", sock, wsastrerror(err));
-	}
-#else
 	    debug(5, 9) ("connect FD %d: %s\n", sock, xstrerror());
-#endif
     } else {
 #if defined(_SQUID_NEWSOS6_)
 	/* Makoto MATSUSHITA <matusita@ics.es.osaka-u.ac.jp> */
@@ -545,11 +440,7 @@
 	}
 #else
 	errlen = sizeof(err);
-#ifdef _SQUID_MSWIN_
-	x = getsockopt(sock, SOL_SOCKET, SO_ERROR, (char*)&err,(int*) &errlen);
-#else
 	x = getsockopt(sock, SOL_SOCKET, SO_ERROR, &err, &errlen);
-#endif
 	if (x == 0)
 	    errno = err;
 #if defined(_SQUID_SOLARIS_)
@@ -564,15 +455,9 @@
 #endif
 #endif
     }
-#ifdef _SQUID_MSWIN_
-    if (err == 0 || err == WSAEISCONN)
-	status = COMM_OK;
-    else if (WSASetLastError(err), ignoreErrno(err))
-#else
     if (errno == 0 || errno == EISCONN)
 	status = COMM_OK;
     else if (ignoreErrno(errno))
-#endif
 	status = COMM_INPROGRESS;
     else
 	return COMM_ERROR;
@@ -596,27 +481,14 @@
     struct sockaddr_in P;
     struct sockaddr_in M;
     socklen_t Slen;
-#ifdef _SQUID_MSWIN_
-    sde *F = NULL;
-#else
     fde *F = NULL;
-#endif
     Slen = sizeof(P);
     Counter.syscalls.sock.accepts++;
-#ifdef _SQUID_MSWIN_
-    if ((sock = WSAAccept(fd, (struct sockaddr *) &P,(int*) &Slen,NULL,0)) ==INVALID_SOCKET ) {
-	if (ignoreErrno(h_errno)) {
-#else
     if ((sock = accept(fd, (struct sockaddr *) &P, &Slen)) < 0) {
 	if (ignoreErrno(errno)) {
-#endif
 	    debug(50, 5) ("comm_accept: FD %d: %s\n", fd, xstrerror());
 	    return COMM_NOMESSAGE;
-#ifdef _SQUID_MSWIN_
-	} else if (WSAEMFILE == WSAGetLastError()) {
-#else
 	} else if (ENFILE == errno || EMFILE == errno) {
-#endif
 	    debug(50, 3) ("comm_accept: FD %d: %s\n", fd, xstrerror());
 	    return COMM_ERROR;
 	} else {
@@ -634,11 +506,7 @@
     commSetCloseOnExec(sock);
     /* fdstat update */
     fd_open(sock, FD_SOCKET, "HTTP Request");
-#ifdef _SQUID_MSWIN_
-    F = &sd_table[sock];
-#else
-    F = &fd_table[sock];
-#endif
+	F = &fd_table[sock];
     xstrncpy(F->ipaddr, inet_ntoa(P.sin_addr), 16);
     F->remote_port = htons(P.sin_port);
     F->local_port = htons(M.sin_port);
@@ -649,11 +517,7 @@
 void
 commCallCloseHandlers(int fd)
 {
-#ifdef _SQUID_MSWIN_
-    sde *F = &sd_table[fd];
-#else
     fde *F = &fd_table[fd];
-#endif
     close_handler *ch;
     debug(5, 5) ("commCallCloseHandlers: FD %d\n", fd);
     while ((ch = F->close_handler) != NULL) {
@@ -672,11 +536,7 @@
 {
     LOCAL_ARRAY(char, buf, 1024);
     int n;
-#ifdef _SQUID_MSWIN_
-    n = recv(fd, buf, 1024);
-#else
     n = read(fd, buf, 1024);
-#endif
     if (n < 0)
 	debug(5, 3) ("commLingerClose: FD %d read: %s\n", fd, xstrerror());
     comm_close(fd);
@@ -701,30 +561,18 @@
     }
     fd_note(fd, "lingering close");
     commSetTimeout(fd, 10, commLingerTimeout, NULL);
-#ifdef _SQUID_MSWIN_
-    commSetSelectS(fd, COMM_SELECT_READ, commLingerClose, NULL, 0);
-#else
     commSetSelect(fd, COMM_SELECT_READ, commLingerClose, NULL, 0);
-#endif
 }
 #endif
 
 void
 comm_close(int fd)
 {
-#ifdef _SQUID_MSWIN_
-    sde *F = NULL;
-#else
     fde *F = NULL;
-#endif
     debug(5, 5) ("comm_close: FD %d\n", fd);
     assert(fd >= 0);
     assert(fd < Squid_MaxFD);
-#ifdef _SQUID_MSWIN_
-    F = &sd_table[fd];
-#else
     F = &fd_table[fd];
-#endif
     if (F->flags.closing)
 	return;
     if (shutting_down && (!F->flags.open || F->type == FD_FILE))
@@ -737,11 +585,7 @@
     if (F->uses)		/* assume persistent connect count */
 	pconnHistCount(1, F->uses);
     fd_close(fd);		/* update fdstat */
-#ifdef _SQUID_MSWIN_
-    closesocket(fd);
-#else
     close(fd);
-#endif
     Counter.syscalls.sock.closes++;
 }
 
@@ -760,18 +604,11 @@
 #ifdef _SQUID_LINUX_
 	if (ECONNREFUSED != errno)
 #endif
-#ifdef _SQUID_MSWIN_
-	errno = WSAGetLastError();
-#endif
 	    debug(50, 1) ("comm_udp_sendto: FD %d, %s, port %d: %s\n",
 		fd,
 		inet_ntoa(to_addr->sin_addr),
 		(int) htons(to_addr->sin_port),
-#ifdef _SQUID_MSWIN_
-		wsastrerror(errno));
-#else
 		xstrerror());
-#endif
 	return COMM_ERROR;
     }
     return x;
@@ -780,11 +617,7 @@
 void
 commSetDefer(int fd, DEFER * func, void *data)
 {
-#ifdef _SQUID_MSWIN_
-    sde *F = &sd_table[fd];
-#else
     fde *F = &fd_table[fd];
-#endif
     F->defer_check = func;
     F->defer_data = data;
 }
@@ -817,21 +650,12 @@
     close_handler *c;
     debug(5, 5) ("comm_add_close_handler: FD %d, handler=%p, data=%p\n",
 	fd, handler, data);
-#ifdef _SQUID_MSWIN_
-	for (c = sd_table[fd].close_handler; c; c = c->next)
-	assert(c->handler != handler || c->data != data);
-    new->handler = handler;
-    new->data = data;
-    new->next = sd_table[fd].close_handler;
-    sd_table[fd].close_handler = new;
-#else
     for (c = fd_table[fd].close_handler; c; c = c->next)
 	assert(c->handler != handler || c->data != data);
     new->handler = handler;
     new->data = data;
     new->next = fd_table[fd].close_handler;
     fd_table[fd].close_handler = new;
-#endif
     cbdataLock(data);
 }
 
@@ -843,11 +667,7 @@
     /* Find handler in list */
     debug(5, 5) ("comm_remove_close_handler: FD %d, handler=%p, data=%p\n",
 	fd, handler, data);
-#ifdef _SQUID_MSWIN_
-	for (p = sd_table[fd].close_handler; p != NULL; last = p, p = p->next)
-#else
 	for (p = fd_table[fd].close_handler; p != NULL; last = p, p = p->next)
-#endif
 	if (p->handler == handler && p->data == data)
 	    break;		/* This is our handler */
     assert(p != NULL);
@@ -855,11 +675,7 @@
     if (last)
 	last->next = p->next;
     else
-#ifdef _SQUID_MSWIN_
-	sd_table[fd].close_handler = p->next;
-#else
 	fd_table[fd].close_handler = p->next;
-#endif
     cbdataUnlock(p->data);
     safe_free(p);
 }
@@ -871,13 +687,8 @@
     L.l_onoff = 0;		/* off */
     L.l_linger = 0;
     if (setsockopt(fd, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
-#ifdef _SQUID_MSWIN_
-	debug(50, 0) ("commSetNoLinger: FD %d: %s\n", fd, wsastrerror(WSAGetLastError()));
-    sd_table[fd].flags.nolinger = 1;
-#else
 	debug(50, 0) ("commSetNoLinger: FD %d: %s\n", fd, xstrerror());
     fd_table[fd].flags.nolinger = 1;
-#endif
 }
 
 static void
@@ -901,12 +712,8 @@
 {
     int dummy = 0;
 #ifdef _SQUID_MSWIN_
-    int nonblocking = TRUE;
-    if (ioctlsocket(fd, FIONBIO, (unsigned long*)&nonblocking) ==SOCKET_ERROR) {
-	debug(50, 0) ("commSetNonBlocking: FD %d: %s\n", fd, wsastrerror(WSAGetLastError()));
-	return COMM_ERROR;
-    }
-    sd_table[fd].flags.nonblocking = 1;
+    int nonblocking = 1;
+    if (ioctlsocket(fd, FIONBIO, (unsigned long *) &nonblocking) < 0) {
 #else
     int flags;
     if ((flags = fcntl(fd, F_GETFL, dummy)) < 0) {
@@ -914,11 +721,11 @@
 	return COMM_ERROR;
     }
     if (fcntl(fd, F_SETFL, flags | SQUID_NONBLOCK) < 0) {
+#endif
 	debug(50, 0) ("commSetNonBlocking: FD %d: %s\n", fd, xstrerror());
 	return COMM_ERROR;
     }
     fd_table[fd].flags.nonblocking = 1;
-#endif
     return 0;
 }
 
@@ -927,12 +734,8 @@
 {
     int dummy = 0;
 #ifdef _SQUID_MSWIN_
-    int nonblocking=0;
-    if (ioctlsocket(fd, FIONBIO, (unsigned long*)&nonblocking) ==SOCKET_ERROR) {
-	debug(50, 0) ("commSetNonBlocking: FD %d: %s\n", fd, wsastrerror(WSAGetLastError()));
-	return COMM_ERROR;
-    }
-    sd_table[fd].flags.nonblocking = 0;
+    int nonblocking = 0;
+    if (ioctlsocket(fd, FIONBIO, (unsigned long *) &nonblocking) < 0) {
 #else
     int flags;
     if ((flags = fcntl(fd, F_GETFL, dummy)) < 0) {
@@ -940,11 +743,11 @@
 	return COMM_ERROR;
     }
     if (fcntl(fd, F_SETFL, flags & (~SQUID_NONBLOCK)) < 0) {
+#endif
 	debug(50, 0) ("commUnsetNonBlocking: FD %d: %s\n", fd, xstrerror());
 	return COMM_ERROR;
     }
     fd_table[fd].flags.nonblocking = 0;
-#endif
     return 0;
 }
 
@@ -977,9 +780,6 @@
 void
 comm_init(void)
 {
-#ifdef _SQUID_MSWIN_
-    sd_table =(sde*) xcalloc(Squid_MaxFD, sizeof(sde));
-#endif
     fd_table = xcalloc(Squid_MaxFD, sizeof(fde));
     /* XXX account fd_table */
     /* Keep a few file descriptors free so that we don't run out of FD's
@@ -1000,11 +800,7 @@
 	fd, (int) state->offset, state->size);
 
     nleft = state->size - state->offset;
-#ifdef _SQUID_MSWIN_
-    len = send(fd, state->buf + state->offset, nleft);
-#else
     len = write(fd, state->buf + state->offset, nleft);
-#endif
     debug(5, 5) ("commHandleWrite: write() returns %d\n", len);
     fd_bytes(fd, len, FD_WRITE);
     Counter.syscalls.sock.writes++;
@@ -1017,27 +813,10 @@
 	CommWriteStateCallbackAndFree(fd, nleft ? COMM_ERROR : COMM_OK);
     } else if (len < 0) {
 	/* An error */
-#ifdef _SQUID_MSWIN_
-	    if (sd_table[fd].flags.socket_eof) {
-	    debug(50, 2) ("commHandleWrite: FD %d: write failure: %s.\n",
-		fd, wsastrerror(WSAGetLastError()));
-#else
 	    if (fd_table[fd].flags.socket_eof) {
 	    debug(50, 2) ("commHandleWrite: FD %d: write failure: %s.\n",
 		fd, xstrerror());
-#endif
-	    CommWriteStateCallbackAndFree(fd, COMM_ERROR);
-#ifdef _SQUID_MSWIN_
-	} else if (ignoreErrno(errno)) {
-	    debug(50, 2) ("commHandleWrite: FD %d: write failure: %s.\n",
-		fd, wsastrerror(WSAGetLastError()));
-		commSetSelectS(fd,COMM_SELECT_WRITE, commHandleWrite,state, 0);
-	} else {
-	    debug(50, 2) ("commHandleWrite: FD %d: write failure: %s.\n",
-		fd, wsastrerror(WSAGetLastError()));
 	    CommWriteStateCallbackAndFree(fd, COMM_ERROR);
-	}
-#else
 	} else if (ignoreErrno(errno)) {
 	    debug(50, 10) ("commHandleWrite: FD %d: write failure: %s.\n",
 		fd, xstrerror());
@@ -1051,21 +830,16 @@
 		fd, xstrerror());
 	    CommWriteStateCallbackAndFree(fd, COMM_ERROR);
 	}
-#endif
     } else {
 	/* A successful write, continue */
 	state->offset += len;
-	if (state->offset < state->size) {
+	if ((unsigned) state->offset < state->size) {
 	    /* Not done, reinstall the write handler and write some more */
-#ifdef _SQUID_MSWIN_
-	    commSetSelectS(fd,COMM_SELECT_WRITE, commHandleWrite,state,0);
-#else
 	    commSetSelect(fd,
 		COMM_SELECT_WRITE,
 		commHandleWrite,
 		state,
 		0);
-#endif
 	} else {
 	    CommWriteStateCallbackAndFree(fd, COMM_OK);
 	}
@@ -1079,28 +853,16 @@
 void
 comm_write(int fd, char *buf, int size, CWCB * handler, void *handler_data, FREE * free_func)
 {
-#ifdef _SQUID_MSWIN_
-	CommWriteStateData *state = sd_table[fd].rwstate;
-#else
-	CommWriteStateData *state = fd_table[fd].rwstate;
-#endif
+    CommWriteStateData *state = fd_table[fd].rwstate;
     debug(5, 5) ("comm_write: FD %d: sz %d: hndl %p: data %p.\n",
 	fd, size, handler, handler_data);
     if (NULL != state) {
 	debug(5, 1) ("comm_write: fd_table[%d].rwstate != NULL\n", fd);
 	safe_free(state);
-#ifdef _SQUID_MSWIN_
-	sd_table[fd].rwstate = NULL;
-#else
 	fd_table[fd].rwstate = NULL;
-#endif
     }
     assert(state == NULL);
-#ifdef _SQUID_MSWIN_
-	sd_table[fd].rwstate = state = (CommWriteStateData*)xcalloc(1, sizeof(CommWriteStateData));
-#else
-	fd_table[fd].rwstate = state = xcalloc(1, sizeof(CommWriteStateData));
-#endif
+    fd_table[fd].rwstate = state = xcalloc(1, sizeof(CommWriteStateData));
     state->buf = buf;
     state->size = size;
     state->offset = 0;
@@ -1108,11 +870,7 @@
     state->handler_data = handler_data;
     state->free_func = free_func;
     cbdataLock(handler_data);
-#ifdef _SQUID_MSWIN_
-    commSetSelectS(fd, COMM_SELECT_WRITE, commHandleWrite, state, 0);
-#else
     commSetSelect(fd, COMM_SELECT_WRITE, commHandleWrite, state, 0);
-#endif
 }
 
 /* a wrapper around comm_write to allow for MemBuf to be comm_written in a snap */
@@ -1126,26 +884,6 @@
  * hm, this might be too general-purpose for all the places we'd
  * like to use it.
  */
-#ifdef _SQUID_MSWIN_
-int
-WSAignoreErrno(int err)
-{
-    err=WSAGetLastError();
-    errno = err;
-    switch (err) {
-    case WSAEINPROGRESS:
-    case WSAEWOULDBLOCK:
-    case WSAEALREADY:
-	case WSATRY_AGAIN:
-	return 1;
-    default:
-	return 0;
-    }
-    /* NOTREACHED */
-}
-
-#else
-
 int
 ignoreErrno(int ierrno)
 {
@@ -1166,24 +904,15 @@
     }
     /* NOTREACHED */
 }
-#endif
 
 void
 commCloseAllSockets(void)
 {
     int fd;
-#ifdef _SQUID_MSWIN_
-    sde *F = NULL;
-#else
     fde *F = NULL;
-#endif
     PF *callback;
     for (fd = 0; fd <= Biggest_FD; fd++) {
-#ifdef _SQUID_MSWIN_
-	F = &sd_table[fd];
-#else
 	F = &fd_table[fd];
-#endif
 	if (!F->flags.open)
 	    continue;
 	if (F->type != FD_SOCKET)
Index: squid/src/comm_select.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm_select.c,v
retrieving revision 1.1.1.3.4.2.2.4
retrieving revision 1.1.1.3.4.2.2.5
diff -u -r1.1.1.3.4.2.2.4 -r1.1.1.3.4.2.2.5
--- squid/src/comm_select.c	3 Feb 2002 15:15:35 -0000	1.1.1.3.4.2.2.4
+++ squid/src/comm_select.c	30 Apr 2002 17:21:49 -0000	1.1.1.3.4.2.2.5
@@ -1,6 +1,5 @@
-
 /*
- * $Id: comm_select.c,v 1.1.1.3.4.2.2.4 2002/02/03 15:15:35 serassio Exp $
+ * $Id: comm_select.c,v 1.1.1.3.4.2.2.5 2002/04/30 17:21:49 serassio Exp $
  *
  * DEBUG: section 5     Socket Functions
  *
@@ -70,15 +69,6 @@
 
 
 static struct timeval zero_tv;
-#ifdef _SQUID_MSWIN_
-static fd_set global_readsds;
-static fd_set global_writesds;
-static fd_set readsds;
-static fd_set writesds;
-static fd_set errsds;
-static int nreadsds;
-static int nwritesds;
-#endif
 static fd_set global_readfds;
 static fd_set global_writefds;
 static int nreadfds;
@@ -148,11 +138,7 @@
 static int
 commDeferRead(int fd)
 {
-#ifdef _SQUID_MSWIN_
-    sde *F = &sd_table[fd];
-#else
     fde *F = &fd_table[fd];
-#endif
     if (F->defer_check == NULL)
 	return 0;
     return F->defer_check(fd, F->defer_data);
@@ -544,27 +530,21 @@
     PF *hdl = NULL;
     fd_set read_mask;
     fd_set write_mask;
+#ifdef _SQUID_MSWIN_
+    fd_set errfds;
+    FD_ZERO(&errfds);
+#endif
     FD_ZERO(&read_mask);
     FD_ZERO(&write_mask);
     for (i = 0; i < nfds; i++) {
 	fd = fds[i];
-#ifdef _SQUID_MSWIN_
-	if (sd_table[fd].read_handler) {
-	    FD_SET((SOCKET) fd, &read_mask);
-#else
 	if (fd_table[fd].read_handler) {
 	    FD_SET(fd, &read_mask);
-#endif
 	    if (fd > maxfd)
 		maxfd = fd;
 	}
-#ifdef _SQUID_MSWIN_
-	if (sd_table[fd].write_handler) {
-	    FD_SET((SOCKET) fd, &write_mask);
-#else
 	if (fd_table[fd].write_handler) {
 	    FD_SET(fd, &write_mask);
-#endif
 	    if (fd > maxfd)
 		maxfd = fd;
 	}
@@ -575,20 +555,18 @@
     getCurrentTime();
 #endif
     Counter.syscalls.selects++;
+#ifdef _SQUID_MSWIN_
+    if (select(maxfd, &read_mask, &write_mask, &errfds, &zero_tv) < 1)
+#else
     if (select(maxfd, &read_mask, &write_mask, NULL, &zero_tv) < 1)
+#endif
 	return incame;
     for (i = 0; i < nfds; i++) {
 	fd = fds[i];
 	if (FD_ISSET(fd, &read_mask)) {
-#ifdef _SQUID_MSWIN_
-	    if ((hdl = sd_table[fd].read_handler) != NULL) {
-		sd_table[fd].read_handler = NULL;
-		commUpdateReadBitsS(fd, NULL);
-#else
 	    if ((hdl = fd_table[fd].read_handler) != NULL) {
 		fd_table[fd].read_handler = NULL;
 		commUpdateReadBits(fd, NULL);
-#endif
 		hdl(fd, &incame);
 	    } else {
 		debug(5, 1) ("comm_select_incoming: FD %d NULL read handler\n",
@@ -596,15 +574,9 @@
 	    }
 	}
 	if (FD_ISSET(fd, &write_mask)) {
-#ifdef _SQUID_MSWIN_
-	    if ((hdl = sd_table[fd].write_handler) != NULL) {
-		sd_table[fd].write_handler = NULL;
-		commUpdateWriteBitsS(fd, NULL);
-#else
 	    if ((hdl = fd_table[fd].write_handler) != NULL) {
 		fd_table[fd].write_handler = NULL;
 		commUpdateWriteBits(fd, NULL);
-#endif
 		hdl(fd, &incame);
 	    } else {
 		debug(5, 1) ("comm_select_incoming: FD %d NULL write handler\n",
@@ -687,12 +659,14 @@
     static time_t last_timeout = 0;
     struct timeval poll_time;
     double timeout = current_dtime + (msec / 1000.0);
-#ifdef _SQUID_MSWIN_
-    sde *F;
-#else
     fde *F;
     fd_set readfds;
     fd_set writefds;
+#ifdef _SQUID_MSWIN_
+    int no_bits;
+    fd_set errfds;
+    FD_ZERO(&errfds);
+#else
     int k;
     fd_mask *fdsp;
     fd_mask tmask;
@@ -717,23 +691,29 @@
 	callicp = calldns = callhttp = 0;
 	maxfd = Biggest_FD + 1;
 #ifdef _SQUID_MSWIN_
-	FD_ZERO(&readsds);
-	FD_ZERO(&writesds);
-	FD_ZERO(&errsds);
-	xmemcpy(&readsds, &global_readsds,sizeof(global_readsds));
-	xmemcpy(&writesds, &global_writesds,sizeof(global_writesds));
-	xmemcpy(&errsds, &global_writesds,sizeof(global_writesds));
-	for (j = 0; j < (int) readsds.fd_count; j++) {
-	    fd=readsds.fd_array[j];
+	xmemcpy(&readfds, &global_readfds, sizeof(global_readfds));
+	xmemcpy(&writefds, &global_writefds, sizeof(global_writefds));
+	for (j = 0; j < (int) readfds.fd_count; j++) {
+	    no_bits = 1;
+	    for ( fd = Biggest_FD; fd; fd-- ) {
+		if (_get_osfhandle(fd) == readfds.fd_array[j]) {
+		    if (fd_table[fd].flags.open) { 
+			no_bits = 0;
+			break;
+		    }
+		}
+	    }
+	    if (no_bits)
+	        continue;
 	    switch (commDeferRead(fd)) {
 	    case 0:
 		break;
 	    case 1:
-		FD_CLR((SOCKET) fd, &readsds);
+		FD_CLR(fd, &readfds);
 		break;
 #if DELAY_POOLS
 	    case -1:
-		FD_SET((SOCKET) fd, &slowfds);
+		FD_SET(fd, &slowfds);
 		break;
 #endif
 	    default:
@@ -788,17 +768,13 @@
 	    }
 	}
 #endif
-#ifdef _SQUID_MSWIN_
-	if (nreadsds + nwritesds == 0) {
-#else
 	if (nreadfds + nwritefds == 0) {
-#endif
 	    assert(shutting_down);
 	    return COMM_SHUTDOWN;
 	}
 	if (msec > MAX_POLL_TIME)
 	    msec = MAX_POLL_TIME;
-#if defined(_SQUID_OS2_) || defined(_SQUID_MSWIN_)
+#if defined(_SQUID_OS2_)
 	if (msec < 0)
 	    msec = MAX_POLL_TIME;
 #endif
@@ -807,22 +783,18 @@
 	    poll_time.tv_usec = (msec % 1000) * 1000;
 	    Counter.syscalls.selects++;
 #ifdef _SQUID_MSWIN_
-	    num = select(maxfd, &readsds, &writesds, &errsds, &poll_time);
+	    num = select(maxfd, &readfds, &writefds, &errfds, &poll_time);
 #else
 	    num = select(maxfd, &readfds, &writefds, NULL, &poll_time);
 #endif
-		Counter.select_loops++;
+	    Counter.select_loops++;
 	    if (num >= 0)
 		break;
 	    if (ignoreErrno(errno))
 		break;
 	    debug(50, 0) ("comm_select: select failure: %s\n",
 		xstrerror());
-#ifdef _SQUID_MSWIN_
-	    examine_select(&readsds, &writesds);
-#else
 	    examine_select(&readfds, &writefds);
-#endif
 	    return COMM_ERROR;
 	    /* NOTREACHED */
 	}
@@ -841,8 +813,19 @@
 	    continue;
 	/* Scan return fd masks for ready descriptors */
 #ifdef _SQUID_MSWIN_
-	for (j = 0; j < (int) readsds.fd_count; j++) {
-		fd=readsds.fd_array[j];
+	assert(readfds.fd_count <= (unsigned int) Biggest_FD);
+	for (j = 0; j < (int) readfds.fd_count; j++) {
+	    no_bits = 1;
+	    for ( fd = Biggest_FD; fd; fd-- ) {
+		if ( _get_osfhandle(fd) == readfds.fd_array[j] ) {
+		    if (fd_table[fd].flags.open) { 
+			no_bits = 0;
+			break;
+		    }
+		}
+	    }
+	    if (no_bits)
+	        continue;
 #else
 	fdsp = (fd_mask *) & readfds;
 	maxindex = howmany(maxfd, FD_MASK_BITS);
@@ -874,11 +857,7 @@
 		    callhttp = 1;
 		    continue;
 		}
-#ifdef _SQUID_MSWIN_
-		F = &sd_table[fd];
-#else
 		F = &fd_table[fd];
-#endif
 		debug(5, 6) ("comm_select: FD %d ready for reading\n", fd);
 		if (NULL == (hdl = F->read_handler))
 		    (void) 0;
@@ -888,11 +867,7 @@
 #endif
 		else {
 		    F->read_handler = NULL;
-#ifdef _SQUID_MSWIN_
-		    commUpdateReadBitsS(fd, NULL);
-#else
 		    commUpdateReadBits(fd, NULL);
-#endif
 		    hdl(fd, F->read_data);
 		    Counter.select_fds++;
 		    if (commCheckICPIncoming)
@@ -902,20 +877,39 @@
 		    if (commCheckHTTPIncoming)
 			comm_select_http_incoming();
 		}
-	}
+	    }
 #ifdef _SQUID_MSWIN_
-	for (j = 0; j < (int) errsds.fd_count; j++) {
-		fd=errsds.fd_array[j];
-		F = &sd_table[fd];
-		if ((hdl = F->write_handler)) {
+#if 1
+	    assert(errfds.fd_count <= (unsigned int) Biggest_FD);
+	    for (j = 0; j < (int) errfds.fd_count; j++) {
+		for ( fd = Biggest_FD; fd; fd-- ) {
+		    if ( _get_osfhandle(fd) == errfds.fd_array[j] )
+			break;
+		}
+		if (fd_table[fd].flags.open) { 
+		    F = &fd_table[fd];
+		    if ((hdl = F->write_handler)) {
 			F->write_handler = NULL;
-			commUpdateWriteBitsS(fd, NULL);
+			commUpdateWriteBits(fd, NULL);
 			hdl(fd, F->write_data);
 			Counter.select_fds++;
+		    }
 		}
-	}
-	for (j = 0; j < (int) writesds.fd_count; j++) {
-		fd=writesds.fd_array[j];
+	    }
+#endif
+	    assert(writefds.fd_count <= (unsigned int) Biggest_FD);
+	    for (j = 0; j < (int) writefds.fd_count; j++) {
+		no_bits = 1;
+		for ( fd = Biggest_FD; fd; fd-- ) {
+		    if ( _get_osfhandle(fd) == writefds.fd_array[j] ) {
+			if (fd_table[fd].flags.open) { 
+			    no_bits = 0;
+			    break;
+			}
+		    }
+		}
+		if (no_bits)
+		    continue;
 #else
 	}
 	fdsp = (fd_mask *) & writefds;
@@ -947,19 +941,11 @@
 		    callhttp = 1;
 		    continue;
 		}
-#ifdef _SQUID_MSWIN_
-		F = &sd_table[fd];
-#else
 		F = &fd_table[fd];
-#endif
 		debug(5, 5) ("comm_select: FD %d ready for writing\n", fd);
 		if ((hdl = F->write_handler)) {
 		    F->write_handler = NULL;
-#ifdef _SQUID_MSWIN_
-		    commUpdateWriteBitsS(fd, NULL);
-#else
 		    commUpdateWriteBits(fd, NULL);
-#endif
 		    hdl(fd, F->write_data);
 		    Counter.select_fds++;
 		    if (commCheckICPIncoming)
@@ -969,9 +955,9 @@
 		    if (commCheckHTTPIncoming)
 			comm_select_http_incoming();
 #ifndef _SQUID_MSWIN_
-	    }
-#endif
 		}
+#endif
+	    }
 	}
 	if (callicp)
 	    comm_select_icp_incoming();
@@ -981,11 +967,7 @@
 	    comm_select_http_incoming();
 #if DELAY_POOLS
 	while ((fd = commGetSlowFd()) != -1) {
-#ifdef _SQUID_MSWIN_
-		F = &sd_table[fd];
-#else
-		F = &fd_table[fd];
-#endif
+	    F = &fd_table[fd];
 	    debug(5, 6) ("comm_select: slow FD %d selected for reading\n", fd);
 	    if ((hdl = F->read_handler)) {
 		F->read_handler = NULL;
@@ -1080,9 +1062,9 @@
 	FD_ZERO(&write_x);
 	tv.tv_sec = tv.tv_usec = 0;
 	if (FD_ISSET(fd, readfds))
-	    FD_SET((SOCKET) fd, &read_x);
+	    FD_SET(fd, &read_x);
 	else if (FD_ISSET(fd, writefds))
-	    FD_SET((SOCKET) fd, &write_x);
+	    FD_SET(fd, &write_x);
 	else
 	    continue;
 	Counter.syscalls.selects++;
@@ -1114,8 +1096,8 @@
 	F->timeout_handler = NULL;
 	F->read_handler = NULL;
 	F->write_handler = NULL;
-	FD_CLR((SOCKET) fd, readfds);
-	FD_CLR((SOCKET) fd, writefds);
+	FD_CLR(fd, readfds);
+	FD_CLR(fd, writefds);
     }
     return 0;
 }
@@ -1125,42 +1107,10 @@
 checkTimeouts(void)
 {
     int fd;
-#ifdef _SQUID_MSWIN_
-    sde *F = NULL;
-    int	j;
-#else
     fde *F = NULL;
-#endif
     PF *callback;
-#ifdef _SQUID_MSWIN_
-    for (j = 0; j < (int) readsds.fd_count; j++) {
-	fd=readsds.fd_array[j];
-	F = &sd_table[fd];
-#else
     for (fd = 0; fd <= Biggest_FD; fd++) {
 	F = &fd_table[fd];
-#endif
-	if (!F->flags.open)
-	    continue;
-	if (F->timeout == 0)
-	    continue;
-	if (F->timeout > squid_curtime)
-	    continue;
-	debug(5, 5) ("checkTimeouts: FD %d Expired\n", fd);
-	if (F->timeout_handler) {
-	    debug(5, 5) ("checkTimeouts: FD %d: Call timeout handler\n", fd);
-	    callback = F->timeout_handler;
-	    F->timeout_handler = NULL;
-	    callback(fd, F->timeout_data);
-	} else {
-	    debug(5, 5) ("checkTimeouts: FD %d: Forcing comm_close()\n", fd);
-	    comm_close(fd);
-	}
-    }
-#ifdef _SQUID_MSWIN_
-    for (j = 0; j < (int) writesds.fd_count; j++) {
-	fd=writesds.fd_array[j];
-	F = &sd_table[fd];
 	if (!F->flags.open)
 	    continue;
 	if (F->timeout == 0)
@@ -1178,7 +1128,6 @@
 	    comm_close(fd);
 	}
     }
-#endif
 }
 
 static void
@@ -1213,40 +1162,15 @@
     statHistDump(&f->comm_http_incoming, sentry, statHistIntDumper);
 }
 
-#ifdef _SQUID_MSWIN_
-void
-commUpdateReadBitsS(int sd, PF * handler)
-{
-    if (handler && !FD_ISSET(sd, &global_readsds)) {
-	FD_SET((SOCKET) sd, &global_readsds);
-	nreadsds++;
-    } else if (!handler && FD_ISSET(sd, &global_readsds)) {
-	FD_CLR((SOCKET) sd, &global_readsds);
-	nreadsds--;
-    }
-}
-
-void
-commUpdateWriteBitsS(int sd, PF * handler)
-{
-    if (handler && !FD_ISSET(sd, &global_writesds)) {
-	FD_SET((SOCKET) sd, &global_writesds);
-	nwritesds++;
-    } else if (!handler && FD_ISSET(sd, &global_writesds)) {
-	FD_CLR((SOCKET) sd, &global_writesds);
-	nwritesds--;
-    }
-}
-#endif
 
 void
 commUpdateReadBits(int fd, PF * handler)
 {
     if (handler && !FD_ISSET(fd, &global_readfds)) {
-	FD_SET((SOCKET) fd, &global_readfds);
+	FD_SET(fd, &global_readfds);
 	nreadfds++;
     } else if (!handler && FD_ISSET(fd, &global_readfds)) {
-	FD_CLR((SOCKET) fd, &global_readfds);
+	FD_CLR(fd, &global_readfds);
 	nreadfds--;
     }
 }
@@ -1255,11 +1179,11 @@
 commUpdateWriteBits(int fd, PF * handler)
 {
     if (handler && !FD_ISSET(fd, &global_writefds)) {
-	FD_SET((SOCKET) fd, &global_writefds);
+	FD_SET(fd, &global_writefds);
 	nwritefds++;
     } else if (!handler && FD_ISSET(fd, &global_writefds)) {
-	FD_CLR((SOCKET) fd, &global_writefds);
+	FD_CLR(fd, &global_writefds);
 	nwritefds--;
     }
 }
-#endif COMM_SELECT_C
+#endif /* COMM_SELECT_C */
